Index: NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg
===================================================================
--- NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 15023)
+++ NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 15032)
@@ -46,14 +46,4 @@
 &namtsd        !    Temperature & Salinity Data                         (default: OFF)
 !-----------------------------------------------------------------------
-   !                       ! =T  read T-S fields for:
-   ln_tsd_init = .true.          !  ocean initialisation
-   ln_tsd_dmp  = .false.         !  T-S restoring   (see namtra_dmp)
-
-   cn_dir = './'     !  root directory for the T-S data location
-   !___________!_________________________!___________________!___________!_____________!________!___________!__________________!__________!_______________!
-   !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ ! weights filename ! rotation ! land/sea mask !
-   !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                  ! pairing  !    filename   !
-   sn_tem = 'data_1m_potential_temperature_nomask',     -1.   ,'votemper',   .true.    , .true. , 'yearly'  ,    ''    ,    ''    ,    ''
-   sn_sal = 'data_1m_salinity_nomask'             ,     -1.   ,'vosaline',   .true.    , .true. , 'yearly'  ,    ''    ,    ''    ,    ''
 /
 !!======================================================================
@@ -116,13 +106,16 @@
 !-----------------------------------------------------------------------
    !                       ! type of penetration                        (default: NO selection)
-   ln_qsr_rgb  = .true.       !  RGB light penetration (Red-Green-Blue)
-   !
-   nn_chldta   =      1       !  RGB : Chl data (=1) or cst value (=0)
+   ln_qsr_2bd  = .true.    !  2BD light penetration (two bands)
+   !                       !  RGB & 2BD choices:
+   rn_si1      =   10.0       !  2BD : longest depth of extinction
+   ln_qsr_rgb  = .false.      !  RGB light penetration (Red-Green-Blue)
+   !
+   nn_chldta   =      0       !  RGB : Chl data (=1) or cst value (=0)
 
    cn_dir      = './'      !  root directory for the chlorophyl data location
-   !___________!_________________________!___________________!___________!_____________!________!___________!______________________________________!__________!_______________!
-   !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ !          weights filename            ! rotation ! land/sea mask !
-   !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                                      ! pairing  !    filename   !
-   sn_chl      ='chlorophyll'            ,        -1.        , 'CHLA'    ,   .true.    , .true. , 'yearly'  , ''                                   , ''       , ''
+   !___________!_________________________!___________________!___________!_____________!________!___________!_______________________________!__________!_______________!
+   !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ !          weights filename     ! rotation ! land/sea mask !
+   !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                               ! pairing  !    filename   !
+   sn_chl      ='chlorophyll'            ,        -1.        , 'CHLA'    ,   .true.    , .true. , 'yearly'  , 'weights_ORCA2_nordic1_bilin' , ''       , ''
 /
 !-----------------------------------------------------------------------
@@ -161,6 +154,5 @@
 &namagrif      !  AGRIF zoom                                            ("key_agrif")
 !-----------------------------------------------------------------------
-   ln_spc_dyn    = .true.  !  use 0 as special value for dynamics
-   ln_chk_bathy  = .false. !  =T  check the parent bathymetry
+   ln_init_chfrpar = .true. !  initialize child grids from parent
 /
 !-----------------------------------------------------------------------